﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using Infragistics.WebUI.UltraWebGrid.DocumentExport;
using Infragistics.Documents.Reports;
using Infragistics.Documents.Reports.Report;
using Infragistics.WebUI.UltraWebGrid;



public partial class _Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
		DataSet set = new DataSet();
		//Add two tables
		set.Tables.Add(BuildTable("Parent"));
		set.Tables.Add(BuildChildTable("Child"));

		//Create relations
		DataColumn parentColumn = set.Tables[0].Columns["id"];
		DataColumn childColumn = set.Tables[1].Columns["relation"];
		DataRelation relation = new DataRelation("RelationName", parentColumn, childColumn);
		set.Relations.Add(relation);

		this.UltraWebGrid1.InitializeLayout += new Infragistics.WebUI.UltraWebGrid.InitializeLayoutEventHandler(UltraWebGrid1_InitializeLayout);
		this.UltraWebGrid1.DataSource = set;
		this.UltraWebGrid1.DataBind();
		this.UltraWebGrid2.DataSource = GridDataSource(2);
		this.UltraWebGrid2.DataBind();
		this.UltraWebGrid3.DataSource = GridDataSource(3);
		this.UltraWebGrid3.DataBind();

		this.tbnExport.Click += new EventHandler(tbnExport_Click);
    }

	void tbnExport_Click(object sender, EventArgs e)
	{
		UltraWebGridDocumentExporter2.Format = FileFormat.PDF;
		UltraWebGridDocumentExporter2.DownloadName = "Export.pdf";
		UltraWebGridDocumentExporter2.TargetPaperOrientation = PageOrientation.Landscape;

		Report r = new Report();

		Infragistics.Documents.Reports.Report.Section.ISection section = r.AddSection();
		section.PageAlignment.Horizontal = Alignment.Left;
		section.PageAlignment.Vertical = Alignment.Top;

		Infragistics.Documents.Reports.Report.Section.ISection section1 = r.AddSection();
		section1.PageAlignment.Horizontal = Alignment.Right;
		section1.PageAlignment.Vertical = Alignment.Top;

		Infragistics.Documents.Reports.Report.Section.ISection section2 = r.AddSection();
		section2.PageAlignment.Horizontal = Alignment.Center;
		section2.PageAlignment.Vertical = Alignment.Bottom;
		
	    // trigger export
		UltraWebGridDocumentExporter2.Export(UltraWebGrid1, section);
		UltraWebGridDocumentExporter2.Export(UltraWebGrid2, section1);
		UltraWebGridDocumentExporter2.Export(UltraWebGrid3, section2);

	}

	private DataTable GridDataSource(int gridIndex)
	{
		// Create a new DataTable.
		System.Data.DataTable table = new DataTable("Table");
		// Declare variables for DataColumn and DataRow objects.
		DataColumn column;
		DataRow row;

		// Create new DataColumn, set DataType, 
		// ColumnName and add to DataTable.    
		column = new DataColumn();
		column.DataType = System.Type.GetType("System.Int32");
		column.ColumnName = "id";
		column.ReadOnly = true;
		// Add the Column to the DataColumnCollection.
		table.Columns.Add(column);

		// Create second column.
		column = new DataColumn();
		column.DataType = System.Type.GetType("System.String");
		column.ColumnName = "Item";
		column.AutoIncrement = false;
		column.Caption = "Item";
		column.ReadOnly = false;
		column.Unique = false;
		// Add the column to the table. 
		table.Columns.Add(column);

		// Create third column.
		column = new DataColumn();
		column.DataType = System.Type.GetType("System.String");
		column.ColumnName = "Data";
		column.AutoIncrement = false;
		column.Caption = "Data";
		column.ReadOnly = false;
		column.Unique = false;
		// Add the column to the table.
		table.Columns.Add(column);


		// Make the ID column the primary key column.
		DataColumn[] PrimaryKeyColumns = new DataColumn[1];
		PrimaryKeyColumns[0] = table.Columns["id"];
		table.PrimaryKey = PrimaryKeyColumns;



		for (int i = 0; i <= 20; i++)
		{
			row = table.NewRow();
			row["id"] = gridIndex*10 + i;
			row["Item"] = "Item "+gridIndex*10 + i;
			row["Data"] = "Data " + gridIndex * 10 + i;
			table.Rows.Add(row);
		}
		return table;

	}

	private static DataTable BuildTable(string name)
	{

		System.Data.DataTable table = new DataTable(name);
		DataColumn column;
		DataRow row;

		column = new DataColumn();
		column.DataType = System.Type.GetType("System.Int32");
		column.ColumnName = "id";
		column.ReadOnly = true;
		table.Columns.Add(column);

		column = new DataColumn();
		column.DataType = System.Type.GetType("System.String");
		column.ColumnName = "Item";
		column.AutoIncrement = false;
		column.Caption = "Item";
		column.ReadOnly = false;
		column.Unique = false;
		table.Columns.Add(column);

		column = new DataColumn();
		column.DataType = System.Type.GetType("System.String");
		column.ColumnName = "Data";
		column.AutoIncrement = false;
		column.Caption = "Data";
		column.ReadOnly = false;
		column.Unique = false;
		table.Columns.Add(column);

		DataColumn[] PrimaryKeyColumns = new DataColumn[1];
		PrimaryKeyColumns[0] = table.Columns["id"];
		table.PrimaryKey = PrimaryKeyColumns;

		for (int i = 0; i <= 10; i++)
		{
			row = table.NewRow();
			row["id"] = i;
			row["Item"] = "Item " + i;
			row["Data"] = "Data " + i;
			table.Rows.Add(row);
		}
		return table;

	}

	private static DataTable BuildChildTable(string name)
	{
		System.Data.DataTable table = new DataTable(name);
		DataColumn column;
		DataRow row;

		column = new DataColumn();
		column.DataType = System.Type.GetType("System.Int32");
		column.ColumnName = "id";
		column.ReadOnly = true;
		table.Columns.Add(column);

		column = new DataColumn();
		column.DataType = System.Type.GetType("System.String");
		column.ColumnName = "Item";
		column.AutoIncrement = false;
		column.Caption = "Item";
		column.ReadOnly = false;
		column.Unique = false;
		table.Columns.Add(column);

		column = new DataColumn();
		column.DataType = System.Type.GetType("System.String");
		column.ColumnName = "Data";
		column.AutoIncrement = false;
		column.Caption = "Data";
		column.ReadOnly = false;
		column.Unique = false;
		table.Columns.Add(column);


		column = new DataColumn();
		column.DataType = System.Type.GetType("System.Int32");
		column.ColumnName = "relation";
		column.AutoIncrement = false;
		column.Caption = "relation";
		column.ReadOnly = false;
		column.Unique = false;
		table.Columns.Add(column);

		DataColumn[] PrimaryKeyColumns = new DataColumn[1];
		PrimaryKeyColumns[0] = table.Columns["id"];
		table.PrimaryKey = PrimaryKeyColumns;

		for (int i = 0; i <= 110; i++)
		{
			row = table.NewRow();
			row["id"] = i;
			row["Item"] = "Item " + i;
			row["Data"] = "Data " + i;

			if ((i < 10) && (i >= 0))
			{

				row["relation"] = 0;
			}
			else if ((i < 20) && (i >= 10))
			{
				row["relation"] = 1;
			}
			else if ((i < 30) && (i >= 20))
			{
				row["relation"] = 2;
			}
			else if ((i < 40) && (i >= 30))
			{
				row["relation"] = 3;
			}
			else if ((i < 50) && (i >= 40))
			{
				row["relation"] = 4;
			}
			else if ((i < 60) && (i >= 50))
			{
				row["relation"] = 5;
			}
			else if ((i < 70) && (i >= 60))
			{
				row["relation"] = 6;
			}
			else if ((i < 80) && (i >= 70))
			{
				row["relation"] = 7;
			}
			else if ((i < 90) && (i >= 80))
			{
				row["relation"] = 8;
			}
			else if ((i < 100) && (i >= 90))
			{
				row["relation"] = 9;
			}
			else if ((i < 110) && (i >= 100))
			{
				row["relation"] = 10;
			}
			table.Rows.Add(row);
		}
		return table;

	}

	void UltraWebGrid1_InitializeLayout(object sender, Infragistics.WebUI.UltraWebGrid.LayoutEventArgs e)
	{
		((UltraWebGrid)sender).Bands[0].Columns[0].Width = Unit.Percentage(60);
		((UltraWebGrid)sender).Bands[1].Columns[0].Width = Unit.Percentage(60);

		//Set Scrollbar 
		UltraWebGrid1.DisplayLayout.ScrollBar =
			Infragistics.WebUI.UltraWebGrid.ScrollBar.Always;
	}
}